package com.ggj.ggj12 
{
	import com.ggj.ggj12.geom.Line;
	import com.ggj.ggj12.utils.MathUtils;
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	/**
	 * ...
	 * @author Jim
	 */
	public class Indicator extends Sprite
	{
		private var _getPtA:Function;
		private var _ptB:Point;
		private var _viewWidth:Number;
		private var _viewHeight:Number;
		
		public function Indicator(getPtA:Function, ptB:Point, viewWidth:Number, viewHeight:Number) 
		{
			_getPtA = getPtA;
			_ptB = ptB;
			_viewWidth = viewWidth;
			_viewHeight = viewHeight;
			this.alpha = 0;
			//trace("indicator spawned");
		}
		
		public function update():void
		{
			var ptA:Point = _getPtA();			

			var r:Rectangle = new Rectangle(ptA.x-_viewWidth/2, ptA.y-_viewHeight/2, _viewWidth, _viewHeight);
			var intersection:Point = null;
			
			var topLeft:Point = r.topLeft;
			var bottomRight:Point = r.bottomRight;
			var topRight:Point = new Point(topLeft.x + r.width, topLeft.y);
			var bottomLeft:Point = new Point(topLeft.x, topLeft.y + r.height);
			
			var l0:Line = new Line(ptA, _ptB);
			var l1:Line = new Line(topLeft, topRight);
			var l2:Line = new Line(topRight, bottomRight);
			var l3:Line = new Line(bottomRight, bottomLeft);
			var l4:Line = new Line(bottomLeft, topLeft);

			intersection = MathUtils.lineLineIntersection(l0, l1);
			if (!intersection) {
				intersection = MathUtils.lineLineIntersection(l0, l2);
			}
			if (!intersection) {
				intersection = MathUtils.lineLineIntersection(l0, l3);
			}
			if (!intersection) {
				intersection = MathUtils.lineLineIntersection(l0, l4);
			}
			
			if (!intersection) {
				//trace("indicator no intersection");
				this.alpha = 0;
			} else {
				//trace("indicator got intersection");
				this.alpha = 0.5;
				this.x = intersection.x;
				this.y = intersection.y;
			}
		}
		
		public function draw():void
		{
			graphics.beginFill(0xdddddd);
			graphics.drawCircle(0, 0, 5);
			graphics.endFill();	
		}		
	}

}