package com.ggj.ggj12 
{
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	import flash.net.URLRequest;
	import flash.utils.Dictionary;
	import flash.utils.Timer;
	/**
	 * ...
	 * @author Jim
	 */
	public class SoundManager 
	{
		public static const BACKGROUND:int = 0;
		
		public static const METAL1:int = 1;
		public static const METAL2:int = 2;
		public static const METAL3:int = 3;
		
		public static const PLANT1:int = 4;
		public static const PLANT2:int = 5;
		public static const PLANT3:int = 6;

		public static const FIRE1:int = 7;
		public static const FIRE2:int = 8;
		public static const FIRE3:int = 9;
		
		public static const BITE:int = 10;
		public static const BIRTH:int = 11;
		public static const GENERATOR:int = 12;
		
		public static const METAL12:int = 13;
		public static const METAL123:int = 14;
		
		public static const PLANT12:int = 15;
		public static const PLANT123:int = 16;
		
		public static const FIRE12:int = 17;
		public static const FIRE123:int = 18;

		public static const DEVOUR:int = 19;
		
		private static const _audiodir:String = "../../assets/audio/";
		
		private var _sounds:Array;
		private var _sources:Dictionary;
		private var _nextSrcId:int;
		
		private var _listener:Point;
		
		private static var _instance:SoundManager = null;
		
		private function _loadSound(id:int, filename:String):void
		{
			_sounds[id] = new Sound(new URLRequest(_audiodir + filename));
		}
		
		public function SoundManager() 
		{
			if (_instance) {
				throw(new Error("use SoundManager.getInstance. don't call new SoundManager()"));
			}
			_nextSrcId = 0;
			_sounds = new Array();
			_sources = new Dictionary();
			
			_loadSound(BACKGROUND, "ambient-1.mp3");
			
			_loadSound(METAL1, "metal-1.mp3");
			_loadSound(METAL2, "metal-2.mp3");
			_loadSound(METAL3, "metal-3.mp3");
			_loadSound(METAL12, "metal-12.mp3");
			_loadSound(METAL123, "metal-123.mp3");
			
			_loadSound(PLANT1, "plant-1.mp3");
			_loadSound(PLANT2, "plant-2.mp3");
			_loadSound(PLANT3, "plant-3.mp3");
			_loadSound(PLANT12, "plant-12.mp3");
			_loadSound(PLANT123, "plant-123.mp3");
			
			_loadSound(FIRE1, "fire-1.mp3");
			_loadSound(FIRE2, "fire-2.mp3");
			_loadSound(FIRE3, "fire-3.mp3");
			_loadSound(FIRE12, "fire-12.mp3");
			_loadSound(FIRE123, "fire-123.mp3");

			_loadSound(BITE, "bitetail-1.mp3");
			_loadSound(DEVOUR, "devour-1.mp3");
			_loadSound(BIRTH, "birth-1.mp3");
			_loadSound(GENERATOR, "generator-1.mp3");	
		}
		
		private function playLoops(e:Event):void
		{
			//trace("playloops");
			for each (var src:SoundSource in _sources) {
				if (src.channel) {
					src.channel.stop();
					src.channel.removeEventListener(Event.SOUND_COMPLETE, playLoops);
				}
				var t:SoundTransform = new SoundTransform(0, 0);
				src.channel = src.sound.play(0, 0, t); /* start muted */
				if (_listener) {
					src.adjust(_listener);
				}				
			}
			src = SoundSource(_sources[0]);
			src.channel.addEventListener(Event.SOUND_COMPLETE, playLoops);
		}
		
		public static function getInstance():SoundManager
		{
			if (!_instance) {
				_instance = new SoundManager();
			}
			return _instance;
		}
		
		public function createSoundSource(id:int, getPos:Function, baseVol:Number=.5, startOffset:Number=0, startImmediately:Boolean=false):int
		{
			trace("createSoundSource vol", baseVol);
			//var ch:SoundChannel = Sound(_sounds[id]).play(startOffset, int.MAX_VALUE);
			var srcId:int = _nextSrcId++;
			var src:SoundSource = new SoundSource(_sounds[id], getPos, baseVol);
			_sources[srcId] = src;
			if (startImmediately) {
				var t:SoundTransform = new SoundTransform(0, 0);
				src.channel = src.sound.play(0, 0, t);
				if (_listener) {
					src.adjust(_listener);
				}
			}
			
			if (id == BACKGROUND) {
				src.channel.addEventListener(Event.SOUND_COMPLETE, playLoops);
			}
			return srcId;
		}
		
		public function getSoundSource(srcId:int):SoundSource
		{
			return _sources[srcId];
		}
		
		public function getSound(srcId:int):Sound
		{
			return _sounds[srcId];
		}
		
		public function removeSoundSource(srcId:int):void
		{
			var src:SoundSource = SoundSource(_sources[srcId]);
			if (src.channel) {
				src.channel.stop();
			}
			delete _sources[srcId];
		}
		
		public function createSoundEffect(id:int, vec:Point, baseVol:Number=.5):void
		{
			//var ch:SoundChannel = Sound(_sounds[id]).play();
			var f:Function = function():Point { return vec; };
			var src:SoundSource = new SoundSource(_sounds[id], f, baseVol);
			src.channel = src.sound.play(0, 0);
		}
		
		public function adjustAll(listener:Point):void
		{
			_listener = listener;
			for each (var src:SoundSource in _sources) {
				src.adjust(listener);
			}
		}
	}

}