package com.ggj.ggj12 
{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.media.Sound;
	import flash.media.SoundChannel;
	import flash.media.SoundTransform;
	/**
	 * ...
	 * @author Jim
	 */
	public class SoundSource 
	{
		private var _channel:SoundChannel;
		private var _getPos:Function;
		private var _baseVol:Number;
		private var _sound:Sound;
		
		public function SoundSource(sound:Sound, getPos:Function, baseVol:Number) 
		{			
			_sound = sound;
			_getPos = getPos;
			_baseVol = baseVol;
		}		
		
		private function transformOfVec(vec:Point):SoundTransform
		{
			var vol:Number;
			var dist:Number = vec.length / 500; /* Fudge factor, stretch out dropoff */
			if (dist <= 1) {
				vol = 1;
			} else {
				vol = 1/(dist*dist);
			}
			vol *= _baseVol;
			
			var panning:Number = 0;
			if (vec.length > 0) {
				panning = ( -vec.x / vec.length) * Math.exp( -1 / (vec.length/50));;
			} else {
				panning = 0;
			}

			var transform:SoundTransform = new SoundTransform(vol, panning);
			return transform;
		}
		
		public function adjust(listener:Point):void
		{
			var pt:Point = _getPos();
			var vec:Point = listener.subtract(pt);
			if (_channel) {
				_channel.soundTransform = transformOfVec(vec);
			}
		}

		public function switchSound(s:Sound):void
		{
			_sound = s;
			/*
			var pos:Number = _channel.position;
			_channel.stop();
			pos = 0;
			//var t:SoundTransform = _channel.soundTransform;
			_channel = s.play(pos, int.MAX_VALUE);
			*/
		}
		
		public function get channel():SoundChannel 
		{
			return _channel;
		}
		
		public function set channel(value:SoundChannel):void 
		{
			_channel = value;
		}
		
		public function get sound():Sound 
		{
			return _sound;
		}
		
		public function set sound(value:Sound):void 
		{
			_sound = value;
		}
		
		public function get baseVol():Number 
		{
			return _baseVol;
		}
		
		public function set baseVol(value:Number):void 
		{
			if (_channel) {
				var t:SoundTransform = _channel.soundTransform;
				t = new SoundTransform(t.volume * value / _baseVol, t.pan);
				_channel.soundTransform = t;
			}
			_baseVol = value;
		}
	}

}