package com.ggj.ggj12.models 
{
	import com.ggj.ggj12.geom.Line;
	import flash.geom.Point;
	/**
	 * ...
	 * @author Matt Kucic
	 */
	public class SnakeModel extends Object 
	{
		private var _segments:Array;
		private var _theta:Number;
		private var _hasCreated:Boolean;
		
		public function SnakeModel(segments:uint, initialPosition:Point, initialTheta:Number = 0) 
		{
			super();
			_segments = new Array();
			_theta = -Math.PI/2;
			
			for (var i:int = 0; i < segments; i++)
			{
				_segments[i] = new Point(initialPosition.x, initialPosition.y);
				
			}
		}
		
		public function addSegments(num:int):void
		{
			var lastPt:Point = Point(_segments[_segments.length - 1]);
			for (var i:int = 0; i < num; i++) {
				_segments.push(new Point(lastPt.x, lastPt.y));
			}
		}
		
		public function reposition(velocity:Number = 0, theta:Number = 0):void
		{
			_theta += theta;
			var newSegments:Array = new Array();
			for (var i:int = 1; i < _segments.length; i++)
			{
				newSegments[i] = Point(_segments[i - 1]);
				
			}
			newSegments[0] =  new Point(
				Point(_segments[0]).x + (velocity * Math.cos(_theta)),
				Point(_segments[0]).y + (velocity * Math.sin(_theta)));
			_segments = newSegments;			
		}
		
		public function get theta():Number 
		{
			return _theta;
		}
		
		public function set theta(value:Number):void 
		{
			_theta = value;
		}
		
		public function get segments():Array 
		{
			return _segments;
		}
		
		public function get hasCreated():Boolean 
		{
			return _hasCreated;
		}
		
		public function set hasCreated(value:Boolean):void 
		{
			_hasCreated = value;
		}
		
		public function getLine(startingPoint:int):Line
		{
			return new Line(Point(_segments[startingPoint]), Point(_segments[startingPoint+1]));
		}
		
	}

}