package com.ggj.ggj12.view 
{
	import com.ggj.ggj12.models.PlanetModel;
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author Matt Kucic
	 */
	public class PlanetView extends Sprite 
	{
		private var _model:PlanetModel;
		private var _typeLayer:Bitmap;
		private var _step:int;
		private var _center:Sprite;
		private var _rotatables:Sprite;
		
		public function PlanetView(model:PlanetModel) 
		{
			_model = model;
			_rotatables = new Sprite();
			update();
		}
		
		public function update():void {
			
			//this.x = _model.position.x;
			//this.y = _model.position.y;
			graphics.clear();
			graphics.beginFill(0xdddddd);
			graphics.drawCircle(_model.position.x, _model.position.y, _model.radius);
			graphics.endFill();	
		}
		
		public function update1():void {
			
			_center.rotation += 1;
		}
		
		public function update2():void {
			
			_center.rotation += 1;
		}
		
		public function addTypeLayer(typeLayer:Bitmap):void 
		{
			_typeLayer = typeLayer;
			_typeLayer.x = _model.position.x-(typeLayer.width/2);
			_typeLayer.y = _model.position.y-(typeLayer.height/2);
			_typeLayer.alpha = 0;
			addChild(_typeLayer);
		}
		
		public function addCenter(center:Bitmap):void 
		{			
			var centerSprite:Sprite = new Sprite();
			center.x -= center.width / 2;
			center.y -= center.height / 2;
			centerSprite.addChild(center);
			centerSprite.x = _model.position.x;
			centerSprite.y = _model.position.y;
			centerSprite.width = _typeLayer.width * .7;
			centerSprite.height = _typeLayer.height * .7;		
			_center = centerSprite;
			addChild(_center);
		}
		
		public function addTuft(tuft:Bitmap):void 
		{
			trace("adding tuft");
			var tuftContainer:Sprite = new Sprite();
			addChild(tuftContainer);
			tuft.scaleX = .075;
			tuft.scaleY = .075;
			tuft.x -= tuft.width / 2;
			tuft.y -= (tuft.height+_model.radius);
			tuftContainer.addChild(tuft);
			tuftContainer.x = _model.position.x;
			tuftContainer.y = _model.position.y;
			tuftContainer.rotation = Math.floor(Math.random() * 360);		
			
		}
		
		public function addEatable(eatable:Bitmap):void 
		{
			trace("addEatable");
			var eatableContainer:Sprite = new Sprite();
			addChild(eatableContainer);
			eatable.scaleX = .1 ;
			eatable.scaleY = .1;
			eatable.x -= eatable.width / 2;
			eatable.y -= (eatable.height+_model.radius);
			eatableContainer.addChild(eatable);
			eatableContainer.x = _model.position.x;
			eatableContainer.y = _model.position.y;
			eatableContainer.rotation = Math.floor(Math.random() * 360);
			
		}
		
		public function consume():void 
		{
			for (var i:int = this.numChildren-1; i >=0; i--)
			{
				this.removeChild(this.getChildAt(i));
			}
			
			graphics.clear();
			graphics.beginFill(0xffffff);
			graphics.drawCircle(_model.position.x, _model.position.y, _model.radius);
			graphics.endFill();	
		}
		
		public function get typeLayer():Bitmap 
		{
			return _typeLayer;
		}
		
	}

}