package com.ggj.ggj12.view 
{
	import com.ggj.ggj12.models.SnakeModel;
	import com.ggj.ggj12.Resources;
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author Matt Kucic
	 */
	public class SnakeView extends Sprite 
	{
		private var _snake:Sprite;
		private var _model:SnakeModel;
		private var _snakeHead:Sprite;
		
		private var _leftArrow:Sprite;
		private var _rightArrow:Sprite;
		private var _arrowContainer:Sprite;
		
		
		public function SnakeView(model:SnakeModel) 
		{
			super();
			_snake = new Sprite();
			
			addChild(_snake);
			
			_model = model;
			var headBitmap:Bitmap = new Resources.snakeHead() as Bitmap;
			headBitmap.scaleX = .14;
			headBitmap.scaleY = .14;
			headBitmap.x -= headBitmap.width/2;
			_snakeHead = new Sprite();
			_snakeHead.addChild(headBitmap);
			
			var leftArrow:Bitmap = new Resources.leftArrow() as Bitmap;
			leftArrow.scaleX = .6;
			leftArrow.scaleY = .6;
			leftArrow.x -= leftArrow.width;
			leftArrow.y -= leftArrow.height/2;
			leftArrow.rotation -= 90;

			var rightArrow:Bitmap = new Resources.rightArrow() as Bitmap;
			rightArrow.scaleX = .6;
			rightArrow.scaleY = .6;
			rightArrow.y += rightArrow.height/2;
			rightArrow.rotation = 90;
			//rightArrow.x += rightArrow.width;
			_arrowContainer = new Sprite();
			_arrowContainer.addChild(leftArrow);
			_arrowContainer.addChild(rightArrow);
			_arrowContainer.alpha = .8;
			_snake.addChild(_arrowContainer);
			
			update();			
		}
		
		public function changeStyle():void {
			
		}
		
		public function update():void {
			_snake.graphics.clear();
			_snake.graphics.lineStyle(8, 0xffffff);
			_snake.graphics.moveTo(Point(_model.segments[2]).x, Point(_model.segments[2]).y);
			for (var i:int = 2; i < _model.segments.length; i++)
			{				
				_snake.graphics.lineTo(Point(_model.segments[i]).x, Point(_model.segments[i]).y);
			}
			/*
			_snake.graphics.beginFill(0xffffff);
			_snake.graphics.drawCircle(Point(_model.segments[0]).x, Point(_model.segments[0]).y, 1);
			_snake.graphics.endFill();
			*/			
			_snake.addChild(_snakeHead);
			_snakeHead.x = Point(_model.segments[2]).x;
			_snakeHead.y = Point(_model.segments[2]).y;
			_snakeHead.rotation = (_model.theta * (180 / Math.PI)) - 90;
			
			_arrowContainer.x = Point(_model.segments[2]).x;
			_arrowContainer.y = Point(_model.segments[2]).y;
			_arrowContainer.rotation = _model.theta * (180 / Math.PI);;
			
		}		
		
		public function hideArrows():void 
		{
			_arrowContainer.alpha = 0;
		}
		
		public function showArrows():void 
		{
			_arrowContainer.alpha = .8;
		}
	}

}