package 
{
	import flash.display.Sprite;
	import flash.geom.Point;
	import flash.geom.Vector3D;
	
	/**
	 * ...
	 * @author Matt Kucic
	 */
	public class Snake extends Sprite
	{
		private var _segments:Array;
		private var _snake:Sprite;
		private var _theta:Number;
		private var _velocity:Number;
		
		public function Snake(segmentAmount:uint)
		{
			_segments = new Array();
			_theta = 0;
			
			_snake = new Sprite();
			
			for (var i:int = 0; i < segmentAmount; i++)
			{
				_segments[i] = new Point(0, 0);
				
			}
		}
		
		public function update():void
		{
			var newSegments:Array = new Array();
			for (var i:int = 1; i < _segments.length; i++)
			{
				newSegments[i] = Point(_segments[i - 1]);
				
			}
			newSegments[0] =  new Point(
				Point(_segments[0]).x + (_velocity * Math.cos(_theta)),
				Point(_segments[0]).y + (_velocity * Math.sin(_theta)));
			_segments = newSegments;
			draw();
		}
		
		private function draw():void 
		{
			if (_snake != null) {
				if (_snake.parent == this)
				{
				removeChild(_snake);
				}
				_snake = null;
				_snake = new Sprite();				
			}
			addChild(_snake);
			_snake.graphics.lineStyle(1, 0xaaaaaa);
			_snake.graphics.moveTo(Point(_segments[0]).x, Point(_segments[0]).y);
			for (var i:int = 1; i < _segments.length; i++)
			{
				/*
				_snake.graphics.beginFill(0xaaaaaa);
				_snake.graphics.drawCircle(Point(_segments[i]).x, Point(_segments[i]).y, 5);
				_snake.graphics.endFill();
				*/
				_snake.graphics.lineTo(Point(_segments[i]).x, Point(_segments[i]).y);
			}
			_snake.graphics.beginFill(0xaaaaaa);
			_snake.graphics.drawCircle(Point(_segments[0]).x, Point(_segments[0]).y, 2S);
			_snake.graphics.endFill();
			
		
		}
		
		public function get theta():Number 
		{
			return _theta;
		}
		
		public function set theta(value:Number):void 
		{
			_theta = value;
		}
		
		public function get velocity():Number 
		{
			return _velocity;
		}
		
		public function set velocity(value:Number):void 
		{
			_velocity = value;
		}
		
		
	}
	
}