package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.ui.Mouse;
	
	/**
	 * ...
	 * @author Jim
	 */
	public class Main extends Sprite 
	{
		private var _wheel:Wheel;
		private var _particles:Array;
		private var _bottom:int = 600;

		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			Mouse.hide();
			_wheel = new Wheel();
			_particles = new Array();
			addChild(_wheel);
			_wheel.x = 50;
			_wheel.y = 50;
			_wheel.draw();

			addEventListener(Event.ENTER_FRAME, onEnterFrame);

			// entry point
		}
		
		private function onEnterFrame(e:Event):void 
		{
			/* process wheel */
			_wheel.rotation += _wheel.dTheta;
			_wheel.x = mouseX;
			_wheel.y = mouseY;
			if (_wheel.y > (_bottom-50)) {
				var particle:Particle = new Particle();
				particle.x = _wheel.x;
				particle.y = _wheel.y-_wheel.height/2;
				particle.vX = (Math.random()*5)-2.5;
				particle.vY = -30;
				addChild(particle);
				_particles.push(particle);
			}
			
			/* destroy dropped particles */
			var new_particles:Array = new Array;
			for (var i:int = 0; i < _particles.length; i++) {
				var p:Particle = Particle(_particles[i]);
				if (p.y > _bottom) {
					removeChild(p);
				} else if (p.hitTestObject(_wheel)) {
					_wheel.dTheta += 2;
					removeChild(p);
				} else {
					new_particles.push(p);
				}
			}
			_particles = new_particles;

			trace(_particles.length);
			/* process particles */
			for (i = 0; i < _particles.length; i++) {
				Particle(_particles[i]).update();
				Particle(_particles[i]).draw();
			}
			
		}
		
	}
	
}